//+------------------------------------------------------------------+
//|                                                  TrailingStp_MAForce3Cross2124.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit         = 870;
extern double Lots               = 0.1;
extern double rsi                = 4;
extern double MovingPeriodD      = 14;
extern double MovingPeriod       = 21;
extern double MovingPeriodS      = 24;
extern double MovingShiftD       = 5;
extern double MovingShift        = 3;
extern double MovingShiftS       = 3;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double mad;
   double ma;
   double mas;
   double val;
   double sto;
   double stos;
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   mad=iMA(NULL,0,MovingPeriodD,MovingShiftD,MODE_LWMA,PRICE_WEIGHTED,5);
   ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_LWMA,PRICE_WEIGHTED,3);
   mas=iMA(NULL,0,MovingPeriodS,MovingShiftS,MODE_SMMA,PRICE_CLOSE,3);
   sto=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   stos=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);
   rsi=iRSI(NULL,0,4,PRICE_CLOSE,0);
   //----
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(sto<20 && rsi<30)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(sto>80 && rsi>70) 
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(sto>80 && rsi>70)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            
           }
         else // go to short position
           {
            // should it be closed?
            if(sto<20 && rsi<30)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); 
               }
            }
         }
      }
   }

return(0); 


return(0);